synpco_dm_target_correct(SynPCo) :-
    SynPCo = synpco(2,[PCo1,PCo2],GlobalTrans,GlobalInputSym,VarNames),
    PCo1 = pco(States1,StackSym1,InputSym1,Trans1,(Q01,sym(Z_01)),Qacc1),
    PCo2 = pco(States2,StackSym2,InputSym2,Trans2,(Q02,sym(Z_02)),Qacc2),
    States1 = [q0r0_1,q0r1_1,q1r0_1,q1r1_1,err_1,wait0_1,wait1_1,fin0_1,fin1_1],
    States2 = [q0r0_2,q0r1_2,q1r0_2,q1r1_2,err_2,wait0_2,wait1_2,fin0_2,fin1_2],
    StackSym1 = [sym(f__find_target_type_1),
                 sym(ftt1_1),
                 sym(ftt2_1),
                 sym(ftt_ret_1),
                 sym(get_target_type_1),
                 sym(gtt1_1),
                 sym(gtt2_1),
                 sym(gtt3_1),
                 sym(gtt4_1),
                 sym(gtt5_1),
                 sym(gtt_ret_1),
                 sym(dm_get_target_type_1),
                 sym(dgtt1_1),
                 sym(dgtt2_1),
                 sym(dgtt_ret_1),
                 sym(dm_put_target_type_1),
                 sym(dptt1_1),
                 sym(dptt2_1),
                 sym(dptt2_1),
                 sym(dptt3_1),
                 sym(dptt4_1),
                 sym(dptt5_1),
                 sym(dptt_ret_1),
                 sym(alloc_target_1),
                 sym(at1_1),
                 sym(at2_1),
                 sym(at3_1),
                 sym(at4_1),
                 sym(at_ret_1),
                 sym(dm_register_target_1),
                 sym(drt_rv0_1_1),
                 sym(drt_rv0_2_1),
                 sym(drt_rv0_3_1),
                 sym(drt_rv0_4_1),
                 sym(drt_rv0_5_1),
                 sym(drt_rv0_6_1),
                 sym(drt_rv0_7_1),
                 sym(drt_rv1_8_1),
                 sym(drt_rv0_8_1),
                 sym(drt_rv1_9_1),
                 sym(drt_rv0_9_1),
                 sym(drt_rv1_10_1),
                 sym(drt_rv0_ret_1),
                 sym(drt_rv1_ret_1),
                 sym(dm_unregister_target_1),
                 sym(dur1_1),
                 sym(dur2_1),
                 sym(dur3_1),
                 sym(dur4_1),
                 sym(dur5_1),
                 sym(dur6_1),
                 sym(dur7_1),
                 sym(dur8_1),
                 sym(dur9_1),
                 sym(dur10_1),
                 sym(dur_ret_1),
                 sym(dm_target_init_1),
                 sym(dm_target_exit_1),
                 sym(dte1_1),
                 sym(dte1_1),
                 sym(init_1),
                 sym(init_res_1),
                 sym(test_1),
                 sym(reg_1),
                 sym(unreg_1),
                 sym(done_1),
                 sym(done2_1)],
    StackSym2 = [sym(f__find_target_type_2),
                 sym(ftt1_2),
                 sym(ftt2_2),
                 sym(ftt_ret_2),
                 sym(get_target_type_2),
                 sym(gtt1_2),
                 sym(gtt2_2),
                 sym(gtt3_2),
                 sym(gtt4_2),
                 sym(gtt5_2),
                 sym(gtt_ret_2),
                 sym(dm_get_target_type_2),
                 sym(dgtt1_2),
                 sym(dgtt2_2),
                 sym(dgtt_ret_2),
                 sym(dm_put_target_type_2),
                 sym(dptt1_2),
                 sym(dptt2_2),
                 sym(dptt2_2),
                 sym(dptt3_2),
                 sym(dptt4_2),
                 sym(dptt5_2),
                 sym(dptt_ret_2),
                 sym(alloc_target_2),
                 sym(at1_2),
                 sym(at2_2),
                 sym(at3_2),
                 sym(at4_2),
                 sym(at_ret_2),
                 sym(dm_register_target_2),
                 sym(drt_rv0_1_2),
                 sym(drt_rv0_2_2),
                 sym(drt_rv0_3_2),
                 sym(drt_rv0_4_2),
                 sym(drt_rv0_5_2),
                 sym(drt_rv0_6_2),
                 sym(drt_rv0_7_2),
                 sym(drt_rv1_8_2),
                 sym(drt_rv0_8_2),
                 sym(drt_rv1_9_2),
                 sym(drt_rv0_9_2),
                 sym(drt_rv1_10_2),
                 sym(drt_rv0_ret_2),
                 sym(drt_rv1_ret_2),
                 sym(dm_unregister_target_2),
                 sym(dur1_2),
                 sym(dur2_2),
                 sym(dur3_2),
                 sym(dur4_2),
                 sym(dur5_2),
                 sym(dur6_2),
                 sym(dur7_2),
                 sym(dur8_2),
                 sym(dur9_2),
                 sym(dur10_2),
                 sym(dur_ret_2),
                 sym(dm_target_init_2),
                 sym(dm_target_exit_2),
                 sym(dte1_2),
                 sym(dte1_2),
                 sym(init_2),
                 sym(init_res_2),
                 sym(test_2),
                 sym(reg_2),
                 sym(unreg_2),
                 sym(done_2),
                 sym(done2_2)],
    InputSym1 = [t(alloc),t(free),t(list_underflow),t(expected_err),
                 t(reg_succ),t(unreg_succ),t(final)],
    InputSym2 = [t(alloc),t(free),t(list_underflow),t(expected_err),
                 t(reg_succ),t(unreg_succ),t(final),t(here)],
    Q01 = q0r0_1,
    Q02 = wait0_2,
    Z_01 = init_1,
    Z_02 = init_2,
    Qacc1 = err_1,
    Qacc2 = err_2,
    Trans1 = [tran(from(q0r0_1,[sym(f__find_target_type_1)],gt([targets],[0])),[],to(q0r0_1,[sym(ftt1_1)],[])),
              tran(from(q0r0_1,[sym(f__find_target_type_1)],true),[],to(q0r0_1,[sym(ftt_ret_1)],[])),
              tran(from(q0r0_1,[sym(ftt1_1)],true),[],to(q0r0_1,[sym(ftt2_1)],[])),
              tran(from(q0r0_1,[sym(ftt2_1)],true),[],to(q0r1_1,[],[])),
              tran(from(q0r0_1,[sym(ftt2_1)],true),[],to(q0r0_1,[sym(f__find_target_type_1)],[])),
              tran(from(q0r0_1,[sym(ftt_ret_1)],true),[],to(q0r0_1,[],[])),
              tran(from(q0r0_1,[sym(get_target_type_1)],true),[],to(q1r0_1,[sym(gtt1_1)],[])),
              tran(from(q0r0_1,[sym(gtt1_1)],true),[],to(q0r0_1,[sym(gtt2_1),sym(f__find_target_type_1)],[])),
              tran(from(q0r0_1,[sym(gtt2_1)],true),[],to(q0r0_1,[sym(gtt_ret_1)],[])),
              tran(from(q0r1_1,[sym(gtt2_1)],true),[],to(q0r0_1,[sym(gtt3_1)],[])),
              tran(from(q0r0_1,[sym(gtt3_1)],true),[],to(q0r0_1,[sym(gtt4_1)],[])),
              tran(from(q0r0_1,[sym(gtt3_1)],true),[],to(q0r0_1,[sym(gtt5_1)],[])),
              tran(from(q0r0_1,[sym(gtt4_1)],true),[],to(q0r0_1,[sym(gtt_ret_1)],[])),
              tran(from(q0r0_1,[sym(gtt5_1)],true),[],to(q0r0_1,[sym(gtt_ret_1)],[])),
              tran(from(q0r0_1,[sym(gtt_ret_1)],true),[],to(q0r0_1,[],[])),
              tran(from(q0r0_1,[sym(dm_get_target_type_1)],true),[],to(q0r0_1,[sym(dgtt1_1)],[])),
              tran(from(q0r0_1,[sym(dm_get_target_type_1)],true),[],to(q0r0_1,[sym(dgtt_ret_1)],[])),
              tran(from(q0r0_1,[sym(dgtt1_1)],true),[],to(q0r0_1,[sym(dgtt2_1)],[])),
              tran(from(q0r0_1,[sym(dgtt2_1)],true),[],to(q0r0_1,[sym(dgtt_ret_1),sym(get_target_type_1)],[])),
              tran(from(q0r0_1,[sym(dgtt_ret_1)],true),[],to(q0r0_1,[],[])),
              tran(from(q0r0_1,[sym(dm_put_target_type_1)],true),[],to(q1r0_1,[sym(dptt1_1)],[])),
              tran(from(q0r0_1,[sym(dptt1_1)],true),[],to(q0r0_1,[sym(dptt2_1)],[])),
              tran(from(q0r0_1,[sym(dptt2_1)],true),[],to(q0r0_1,[sym(dptt3_1)],[])),
              tran(from(q0r0_1,[sym(dptt2_1)],true),[],to(q0r0_1,[sym(dptt4_1)],[])),
              tran(from(q0r0_1,[sym(dptt3_1)],true),[],to(q0r0_1,[sym(dptt4_1)],[])),
              tran(from(q0r0_1,[sym(dptt4_1)],true),[],to(q0r0_1,[sym(dptt5_1)],[])),
              tran(from(q0r0_1,[sym(dptt4_1)],true),[],to(q0r0_1,[sym(dptt5_1)],[])),
              tran(from(q0r0_1,[sym(dptt5_1)],true),[],to(q0r0_1,[sym(dptt_ret_1)],[])),
              tran(from(q0r0_1,[sym(dptt_ret_1)],true),[],to(q0r0_1,[],[])),
              tran(from(q0r0_1,[sym(alloc_target_1)],true),[],to(q0r0_1,[sym(at1_1)],[])),
              tran(from(q0r0_1,[sym(at1_1)],true),[t(alloc)],to(q0r0_1,[sym(at2_1)],[])),
              tran(from(q0r0_1,[sym(at2_1)],true),[],to(q0r0_1,[sym(at_ret_1)],[])),
              tran(from(q0r0_1,[sym(at2_1)],true),[],to(q0r0_1,[sym(at3_1)],[])),
              tran(from(q0r0_1,[sym(at3_1)],true),[],to(q0r0_1,[sym(at4_1)],[])),
              tran(from(q0r0_1,[sym(at4_1)],true),[],to(q0r0_1,[sym(at_ret_1)],[])),
              tran(from(q0r0_1,[sym(at_ret_1)],true),[],to(q0r0_1,[],[])),
              tran(from(q0r0_1,[sym(dm_register_target_1)],true),[],to(q0r0_1,[sym(drt_rv0_1_1)],[])),
              tran(from(q0r0_1,[sym(drt_rv0_1_1)],true),[],to(q0r0_1,[sym(drt_rv0_2_1),sym(alloc_target_1)],[])),
              tran(from(q0r0_1,[sym(drt_rv0_2_1)],true),[],to(q1r0_1,[sym(drt_rv0_3_1)],[])),
              tran(from(q0r0_1,[sym(drt_rv0_3_1)],true),[],to(q0r0_1,[sym(drt_rv0_4_1),sym(f__find_target_type_1)],[])),
              tran(from(q0r1_1,[sym(drt_rv0_4_1)],true),[],to(q0r0_1,[sym(drt_rv0_6_1)],[])),
              tran(from(q0r0_1,[sym(drt_rv0_4_1)],true),[],to(q0r0_1,[sym(drt_rv0_7_1)],[])),
              tran(from(q0r0_1,[sym(drt_rv0_6_1)],true),[],to(q0r0_1,[sym(drt_rv1_8_1)],[])),
              tran(from(q0r0_1,[sym(drt_rv0_7_1)],true),[],to(q0r0_1,[sym(drt_rv0_8_1)],[(targets,1)])),
              tran(from(q0r0_1,[sym(drt_rv1_8_1)],true),[],to(q0r0_1,[sym(drt_rv1_9_1)],[])),
              tran(from(q0r0_1,[sym(drt_rv0_8_1)],true),[],to(q0r0_1,[sym(drt_rv0_9_1)],[])),
              tran(from(q0r0_1,[sym(drt_rv1_9_1)],true),[],to(q0r0_1,[sym(drt_rv1_10_1)],[])),
              tran(from(q0r0_1,[sym(drt_rv0_9_1)],true),[],to(q0r0_1,[sym(drt_rv0_ret_1)],[])),
              tran(from(q0r0_1,[sym(drt_rv1_10_1)],true),[t(free)],to(q0r0_1,[sym(drt_rv1_ret_1)],[])),
              tran(from(q0r0_1,[sym(drt_rv1_10_1)],true),[t(free)],to(err_1,[sym(drt_rv1_10_1)],[])),
              tran(from(q0r0_1,[sym(drt_rv0_ret_1)],true),[],to(q0r1_1,[],[])),
              tran(from(q0r0_1,[sym(drt_rv1_ret_1)],true),[],to(q0r0_1,[],[])),
              tran(from(q0r0_1,[sym(dm_unregister_target_1)],true),[],to(q1r0_1,[sym(dur1_1)],[])),
              tran(from(q0r0_1,[sym(dur1_1)],true),[],to(q0r0_1,[sym(dur2_1),sym(f__find_target_type_1)],[])),
              tran(from(q0r0_1,[sym(dur2_1)],true),[],to(q0r0_1,[sym(dur3_1)],[])),
              tran(from(q0r1_1,[sym(dur2_1)],true),[],to(q0r0_1,[sym(dur5_1)],[])),
              tran(from(q0r0_1,[sym(dur3_1)],true),[],to(q0r0_1,[sym(dur4_1)],[])),
              tran(from(q0r0_1,[sym(dur4_1)],true),[],to(q0r0_1,[],[])),
              tran(from(q0r0_1,[sym(dur5_1)],true),[],to(q0r0_1,[sym(dur8_1)],[])),
              tran(from(q0r0_1,[sym(dur5_1)],true),[],to(q0r0_1,[sym(dur6_1)],[])),
              tran(from(q0r0_1,[sym(dur6_1)],true),[],to(q0r0_1,[sym(dur7_1)],[])),
              tran(from(q0r0_1,[sym(dur7_1)],true),[],to(q0r0_1,[],[])),
              tran(from(q0r0_1,[sym(dur8_1)],eq([targets],[0])),[t(list_underflow)],to(err_1,[sym(dur8_1)],[])),
              tran(from(q0r0_1,[sym(dur8_1)],true),[],to(q0r0_1,[sym(dur9_1)],[(targets,-1)])),
              tran(from(q0r0_1,[sym(dur9_1)],true),[t(free)],to(q0r0_1,[sym(dur10_1)],[])),
              tran(from(q0r0_1,[sym(dur9_1)],true),[t(free)],to(err_1,[sym(dur9_1)],[])),
              tran(from(q0r0_1,[sym(dur10_1)],true),[],to(q0r0_1,[sym(dur_ret_1)],[])),
              tran(from(q0r0_1,[sym(dur_ret_1)],true),[],to(q0r1_1,[],[])),
              tran(from(q0r0_1,[sym(dm_target_init_1)],true),[],to(q0r0_1,[sym(dm_register_target_1)],[])),
              tran(from(q0r0_1,[sym(dm_target_exit_1)],true),[],to(q0r0_1,[sym(dte1_1),sym(dm_unregister_target_1)],[])),
              tran(from(q0r0_1,[sym(dte1_1)],true),[t(expected_err)],to(q0r0_1,[],[])),
              tran(from(q0r1_1,[sym(dte1_1)],true),[],to(q0r0_1,[],[])),
              tran(from(q0r0_1,[sym(init_1)],true),[],to(q0r0_1,[sym(init_res_1),sym(dm_target_init_1)],[])),
              tran(from(q0r0_1,[sym(init_res_1)],true),[],to(q0r0_1,[],[])),
              tran(from(q0r1_1,[sym(init_res_1)],true),[],to(q0r0_1,[sym(test_1)],[])),
              tran(from(q0r0_1,[sym(test_1)],true),[],to(q0r0_1,[sym(done_1)],[])),
              tran(from(q0r0_1,[sym(test_1)],true),[],to(q0r0_1,[sym(reg_1),sym(dm_register_target_1)],[])),
              tran(from(q0r0_1,[sym(test_1)],true),[],to(q0r0_1,[sym(unreg_1),sym(dm_unregister_target_1)],[])),
              tran(from(q0r0_1,[sym(test_1)],true),[],to(q0r0_1,[sym(test_1),sym(dm_get_target_type_1)],[])),
              tran(from(q0r0_1,[sym(test_1)],true),[],to(q0r0_1,[sym(test_1),sym(dm_put_target_type_1)],[])),
              tran(from(q0r0_1,[sym(reg_1)],true),[],to(q0r0_1,[sym(test_1)],[])),
              tran(from(q0r1_1,[sym(reg_1)],true),[t(reg_succ)],to(q0r0_1,[sym(test_1)],[])),
              tran(from(q0r0_1,[sym(unreg_1)],true),[],to(q0r0_1,[sym(test_1)],[])),
              tran(from(q0r1_1,[sym(unreg_1)],true),[t(unreg_succ)],to(q0r0_1,[sym(test_1)],[])),
              tran(from(q0r0_1,[sym(done_1)],true),[],to(q0r0_1,[sym(done2_1),sym(dm_target_exit_1)],[])),
              tran(from(q0r0_1,[sym(done2_1)],true),[],to(fin0_1,[sym(done2_1)],[])),
              tran(from(q1r0_1,[sym(done2_1)],true),[],to(fin1_1,[sym(done2_1)],[])),
              tran(from(fin0_1,[sym(done2_1)],true),[t(final)],to(err_1,[sym(done2_1)],[])),
              tran(from(fin1_1,[sym(done2_1)],true),[t(final)],to(err_1,[sym(done2_1)],[])),
              tran(from(q1r0_1,[sym(f__find_target_type_1)],gt([targets],[0])),[],to(q1r0_1,[sym(ftt1_1)],[])),
              tran(from(q1r0_1,[sym(f__find_target_type_1)],true),[],to(q1r0_1,[sym(ftt_ret_1)],[])),
              tran(from(q1r0_1,[sym(ftt1_1)],true),[],to(q1r0_1,[sym(ftt2_1)],[])),
              tran(from(q1r0_1,[sym(ftt2_1)],true),[],to(q1r1_1,[],[])),
              tran(from(q1r0_1,[sym(ftt2_1)],true),[],to(q1r0_1,[sym(f__find_target_type_1)],[])),
              tran(from(q1r0_1,[sym(ftt_ret_1)],true),[],to(q1r0_1,[],[])),
              tran(from(q1r0_1,[sym(gtt1_1)],true),[],to(q1r0_1,[sym(gtt2_1),sym(f__find_target_type_1)],[])),
              tran(from(q1r0_1,[sym(gtt2_1)],true),[],to(q1r0_1,[sym(gtt_ret_1)],[])),
              tran(from(q1r1_1,[sym(gtt2_1)],true),[],to(q1r0_1,[sym(gtt3_1)],[])),
              tran(from(q1r0_1,[sym(gtt3_1)],true),[],to(q1r0_1,[sym(gtt4_1)],[])),
              tran(from(q1r0_1,[sym(gtt3_1)],true),[],to(q1r0_1,[sym(gtt5_1)],[])),
              tran(from(q1r0_1,[sym(gtt4_1)],true),[],to(q1r0_1,[sym(gtt_ret_1)],[])),
              tran(from(q1r0_1,[sym(gtt5_1)],true),[],to(q1r0_1,[sym(gtt_ret_1)],[])),
              tran(from(q1r0_1,[sym(gtt_ret_1)],true),[],to(q0r0_1,[],[])),
              tran(from(q1r0_1,[sym(dm_get_target_type_1)],true),[],to(q1r0_1,[sym(dgtt1_1)],[])),
              tran(from(q1r0_1,[sym(dm_get_target_type_1)],true),[],to(q1r0_1,[sym(dgtt_ret_1)],[])),
              tran(from(q1r0_1,[sym(dgtt1_1)],true),[],to(q1r0_1,[sym(dgtt2_1)],[])),
              tran(from(q1r0_1,[sym(dgtt2_1)],true),[],to(q1r0_1,[sym(dgtt_ret_1),sym(get_target_type_1)],[])),
              tran(from(q1r0_1,[sym(dgtt_ret_1)],true),[],to(q1r0_1,[],[])),
              tran(from(q1r0_1,[sym(dptt1_1)],true),[],to(q1r0_1,[sym(dptt2_1)],[])),
              tran(from(q1r0_1,[sym(dptt2_1)],true),[],to(q1r0_1,[sym(dptt3_1)],[])),
              tran(from(q1r0_1,[sym(dptt2_1)],true),[],to(q1r0_1,[sym(dptt4_1)],[])),
              tran(from(q1r0_1,[sym(dptt3_1)],true),[],to(q1r0_1,[sym(dptt4_1)],[])),
              tran(from(q1r0_1,[sym(dptt4_1)],true),[],to(q1r0_1,[sym(dptt5_1)],[])),
              tran(from(q1r0_1,[sym(dptt4_1)],true),[],to(q1r0_1,[sym(dptt5_1)],[])),
              tran(from(q1r0_1,[sym(dptt5_1)],true),[],to(q1r0_1,[sym(dptt_ret_1)],[])),
              tran(from(q1r0_1,[sym(dptt_ret_1)],true),[],to(q0r0_1,[],[])),
              tran(from(q1r0_1,[sym(alloc_target_1)],true),[],to(q1r0_1,[sym(at1_1)],[])),
              tran(from(q1r0_1,[sym(at1_1)],true),[t(alloc)],to(q1r0_1,[sym(at2_1)],[])),
              tran(from(q1r0_1,[sym(at2_1)],true),[],to(q1r0_1,[sym(at_ret_1)],[])),
              tran(from(q1r0_1,[sym(at2_1)],true),[],to(q1r0_1,[sym(at3_1)],[])),
              tran(from(q1r0_1,[sym(at3_1)],true),[],to(q1r0_1,[sym(at4_1)],[])),
              tran(from(q1r0_1,[sym(at4_1)],true),[],to(q1r0_1,[sym(at_ret_1)],[])),
              tran(from(q1r0_1,[sym(at_ret_1)],true),[],to(q1r0_1,[],[])),
              tran(from(q1r0_1,[sym(dm_register_target_1)],true),[],to(q1r0_1,[sym(drt_rv0_1_1)],[])),
              tran(from(q1r0_1,[sym(drt_rv0_1_1)],true),[],to(q1r0_1,[sym(drt_rv0_2_1),sym(alloc_target_1)],[])),
              tran(from(q1r0_1,[sym(drt_rv0_2_1)],true),[],to(q1r0_1,[sym(drt_rv0_3_1)],[])),
              tran(from(q1r0_1,[sym(drt_rv0_3_1)],true),[],to(q1r0_1,[sym(drt_rv0_4_1),sym(f__find_target_type_1)],[])),
              tran(from(q1r1_1,[sym(drt_rv0_4_1)],true),[],to(q1r0_1,[sym(drt_rv0_6_1)],[])),
              tran(from(q1r0_1,[sym(drt_rv0_4_1)],true),[],to(q1r0_1,[sym(drt_rv0_7_1)],[])),
              tran(from(q1r0_1,[sym(drt_rv0_6_1)],true),[],to(q1r0_1,[sym(drt_rv1_8_1)],[])),
              tran(from(q1r0_1,[sym(drt_rv0_7_1)],true),[],to(q1r0_1,[sym(drt_rv0_8_1)],[(targets,1)])),
              tran(from(q1r0_1,[sym(drt_rv1_8_1)],true),[],to(q0r0_1,[sym(drt_rv1_9_1)],[])),
              tran(from(q1r0_1,[sym(drt_rv0_8_1)],true),[],to(q0r0_1,[sym(drt_rv0_9_1)],[])),
              tran(from(q1r0_1,[sym(drt_rv1_9_1)],true),[],to(q1r0_1,[sym(drt_rv1_10_1)],[])),
              tran(from(q1r0_1,[sym(drt_rv0_9_1)],true),[],to(q1r0_1,[sym(drt_rv0_ret_1)],[])),
              tran(from(q1r0_1,[sym(drt_rv1_10_1)],true),[t(free)],to(q1r0_1,[sym(drt_rv1_ret_1)],[])),
              tran(from(q1r0_1,[sym(drt_rv1_10_1)],true),[t(free)],to(err_1,[sym(drt_rv1_10_1)],[])),
              tran(from(q1r0_1,[sym(drt_rv0_ret_1)],true),[],to(q1r1_1,[],[])),
              tran(from(q1r0_1,[sym(drt_rv1_ret_1)],true),[],to(q1r0_1,[],[])),
              tran(from(q1r0_1,[sym(dm_unregister_target_1)],true),[],to(q1r0_1,[sym(dur1_1)],[])),
              tran(from(q1r0_1,[sym(dur1_1)],true),[],to(q1r0_1,[sym(dur2_1),sym(f__find_target_type_1)],[])),
              tran(from(q1r0_1,[sym(dur2_1)],true),[],to(q1r0_1,[sym(dur3_1)],[])),
              tran(from(q1r1_1,[sym(dur2_1)],true),[],to(q1r0_1,[sym(dur5_1)],[])),
              tran(from(q1r0_1,[sym(dur3_1)],true),[],to(q1r0_1,[sym(dur4_1)],[])),
              tran(from(q1r0_1,[sym(dur4_1)],true),[],to(q0r0_1,[],[])),
              tran(from(q1r0_1,[sym(dur5_1)],true),[],to(q1r0_1,[sym(dur8_1)],[])),
              tran(from(q1r0_1,[sym(dur5_1)],true),[],to(q1r0_1,[sym(dur6_1)],[])),
              tran(from(q1r0_1,[sym(dur6_1)],true),[],to(q1r0_1,[sym(dur7_1)],[])),
              tran(from(q1r0_1,[sym(dur7_1)],true),[],to(q0r0_1,[],[])),
              tran(from(q1r0_1,[sym(dur8_1)],eq([targets],[0])),[t(list_underflow)],to(err_1,[sym(dur8_1)],[])),
              tran(from(q1r0_1,[sym(dur8_1)],true),[],to(q1r0_1,[sym(dur9_1)],[(targets,-1)])),
              tran(from(q1r0_1,[sym(dur9_1)],true),[t(free)],to(q1r0_1,[sym(dur10_1)],[])),
              tran(from(q1r0_1,[sym(dur9_1)],true),[t(free)],to(err_1,[sym(dur9_1)],[])),
              tran(from(q1r0_1,[sym(dur10_1)],true),[],to(q1r0_1,[sym(dur_ret_1)],[])),
              tran(from(q1r0_1,[sym(dur_ret_1)],true),[],to(q0r1_1,[],[])),
              tran(from(q1r0_1,[sym(dm_target_exit_1)],true),[],to(q1r0_1,[sym(dte1_1),sym(dm_unregister_target_1)],[])),
              tran(from(q1r0_1,[sym(dte1_1)],true),[t(expected_err)],to(q1r0_1,[],[])),
              tran(from(q1r1_1,[sym(dte1_1)],true),[],to(q1r0_1,[],[])),
              tran(from(q1r0_1,[sym(init_1)],true),[],to(q1r0_1,[sym(init_res_1),sym(dm_target_init_1)],[])),
              tran(from(q1r0_1,[sym(init_res_1)],true),[],to(q1r0_1,[],[])),
              tran(from(q1r1_1,[sym(init_res_1)],true),[],to(q1r0_1,[sym(test_1)],[])),
              tran(from(q1r0_1,[sym(test_1)],true),[],to(q1r0_1,[sym(done_1)],[])),
              tran(from(q1r0_1,[sym(test_1)],true),[],to(q1r0_1,[sym(reg_1),sym(dm_register_target_1)],[])),
              tran(from(q1r0_1,[sym(test_1)],true),[],to(q1r0_1,[sym(unreg_1),sym(dm_unregister_target_1)],[])),
              tran(from(q1r0_1,[sym(test_1)],true),[],to(q1r0_1,[sym(test_1),sym(dm_get_target_type_1)],[])),
              tran(from(q1r0_1,[sym(test_1)],true),[],to(q1r0_1,[sym(test_1),sym(dm_put_target_type_1)],[])),
              tran(from(q1r0_1,[sym(reg_1)],true),[],to(q1r0_1,[sym(test_1)],[])),
              tran(from(q1r1_1,[sym(reg_1)],true),[t(reg_succ)],to(q1r0_1,[sym(test_1)],[])),
              tran(from(q1r0_1,[sym(unreg_1)],true),[],to(q1r0_1,[sym(test_1)],[])),
              tran(from(q1r1_1,[sym(unreg_1)],true),[t(unreg_succ)],to(q1r0_1,[sym(test_1)],[])),
              tran(from(q1r0_1,[sym(done_1)],true),[],to(q1r0_1,[sym(done2_1),sym(dm_target_exit_1)],[])),
              tran(from(err_1,[sym(f__find_target_type_1)],true),[],to(err_1,[sym(f__find_target_type_1)],[]))],
              %tran(from(err_1,[sym(ftt1_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(ftt2_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(ftt_ret_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(get_target_type_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(gtt1_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(gtt2_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(gtt3_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(gtt4_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(gtt5_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(gtt_ret_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dm_get_target_type_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dgtt1_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dgtt2_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dgtt_ret_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dm_put_target_type_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dptt1_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dptt2_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dptt2_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dptt3_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dptt4_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dptt5_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dptt_ret_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(alloc_target_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(at1_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(at2_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(at3_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(at4_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(at_ret_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dm_register_target_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(drt_rv0_1_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(drt_rv0_2_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(drt_rv0_3_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(drt_rv0_4_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(drt_rv0_5_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(drt_rv0_6_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(drt_rv0_7_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(drt_rv1_8_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(drt_rv0_8_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(drt_rv1_9_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(drt_rv0_9_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(drt_rv1_10_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(drt_rv0_ret_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(drt_rv1_ret_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dm_unregister_target_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dur1_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dur2_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dur3_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dur4_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dur5_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dur6_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dur7_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dur8_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dur9_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dur10_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dur_ret_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dm_target_init_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dm_target_exit_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dte1_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(dte1_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(init_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(init_res_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(test_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(reg_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(unreg_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(done_1)],true),[],to(err_1,[],[])),
              %tran(from(err_1,[sym(done2_1)],true),[],to(err_1,[],[]))],
    Trans2 = [tran(from(q0r0_2,[sym(f__find_target_type_2)],gt([targets],[0])),[],to(q0r0_2,[sym(ftt1_2)],[])),
              tran(from(q0r0_2,[sym(f__find_target_type_2)],true),[],to(q0r0_2,[sym(ftt_ret_2)],[])),
              tran(from(q0r0_2,[sym(ftt1_2)],true),[],to(q0r0_2,[sym(ftt2_2)],[])),
              tran(from(q0r0_2,[sym(ftt2_2)],true),[],to(q0r1_2,[],[])),
              tran(from(q0r0_2,[sym(ftt2_2)],true),[],to(q0r0_2,[sym(f__find_target_type_2)],[])),
              tran(from(q0r0_2,[sym(ftt_ret_2)],true),[],to(q0r0_2,[],[])),
              tran(from(q0r0_2,[sym(get_target_type_2)],true),[],to(q1r0_2,[sym(gtt1_2)],[])),
              tran(from(q0r0_2,[sym(gtt1_2)],true),[],to(q0r0_2,[sym(gtt2_2),sym(f__find_target_type_2)],[])),
              tran(from(q0r0_2,[sym(gtt2_2)],true),[],to(q0r0_2,[sym(gtt_ret_2)],[])),
              tran(from(q0r1_2,[sym(gtt2_2)],true),[],to(q0r0_2,[sym(gtt3_2)],[])),
              tran(from(q0r0_2,[sym(gtt3_2)],true),[],to(q0r0_2,[sym(gtt4_2)],[])),
              tran(from(q0r0_2,[sym(gtt3_2)],true),[],to(q0r0_2,[sym(gtt5_2)],[])),
              tran(from(q0r0_2,[sym(gtt4_2)],true),[],to(q0r0_2,[sym(gtt_ret_2)],[])),
              tran(from(q0r0_2,[sym(gtt5_2)],true),[],to(q0r0_2,[sym(gtt_ret_2)],[])),
              tran(from(q0r0_2,[sym(gtt_ret_2)],true),[],to(q0r0_2,[],[])),
              tran(from(q0r0_2,[sym(dm_get_target_type_2)],true),[],to(q0r0_2,[sym(dgtt1_2)],[])),
              tran(from(q0r0_2,[sym(dm_get_target_type_2)],true),[],to(q0r0_2,[sym(dgtt_ret_2)],[])),
              tran(from(q0r0_2,[sym(dgtt1_2)],true),[],to(q0r0_2,[sym(dgtt2_2)],[])),
              tran(from(q0r0_2,[sym(dgtt2_2)],true),[],to(q0r0_2,[sym(dgtt_ret_2),sym(get_target_type_2)],[])),
              tran(from(q0r0_2,[sym(dgtt_ret_2)],true),[],to(q0r0_2,[],[])),
              tran(from(q0r0_2,[sym(dm_put_target_type_2)],true),[],to(q1r0_2,[sym(dptt1_2)],[])),
              tran(from(q0r0_2,[sym(dptt1_2)],true),[],to(q0r0_2,[sym(dptt2_2)],[])),
              tran(from(q0r0_2,[sym(dptt2_2)],true),[],to(q0r0_2,[sym(dptt3_2)],[])),
              tran(from(q0r0_2,[sym(dptt2_2)],true),[],to(q0r0_2,[sym(dptt4_2)],[])),
              tran(from(q0r0_2,[sym(dptt3_2)],true),[],to(q0r0_2,[sym(dptt4_2)],[])),
              tran(from(q0r0_2,[sym(dptt4_2)],true),[],to(q0r0_2,[sym(dptt5_2)],[])),
              tran(from(q0r0_2,[sym(dptt4_2)],true),[],to(q0r0_2,[sym(dptt5_2)],[])),
              tran(from(q0r0_2,[sym(dptt5_2)],true),[],to(q0r0_2,[sym(dptt_ret_2)],[])),
              tran(from(q0r0_2,[sym(dptt_ret_2)],true),[],to(q0r0_2,[],[])),
              tran(from(q0r0_2,[sym(alloc_target_2)],true),[],to(q0r0_2,[sym(at1_2)],[])),
              tran(from(q0r0_2,[sym(at1_2)],true),[t(alloc)],to(q0r0_2,[sym(at2_2)],[])),
              tran(from(q0r0_2,[sym(at2_2)],true),[],to(q0r0_2,[sym(at_ret_2)],[])),
              tran(from(q0r0_2,[sym(at2_2)],true),[],to(q0r0_2,[sym(at3_2)],[])),
              tran(from(q0r0_2,[sym(at3_2)],true),[],to(q0r0_2,[sym(at4_2)],[])),
              tran(from(q0r0_2,[sym(at4_2)],true),[],to(q0r0_2,[sym(at_ret_2)],[])),
              tran(from(q0r0_2,[sym(at_ret_2)],true),[],to(q0r0_2,[],[])),
              tran(from(q0r0_2,[sym(dm_register_target_2)],true),[t(here)],to(q0r0_2,[sym(drt_rv0_1_2)],[])),
              tran(from(q0r0_2,[sym(drt_rv0_1_2)],true),[],to(q0r0_2,[sym(drt_rv0_2_2),sym(alloc_target_2)],[])),
              tran(from(q0r0_2,[sym(drt_rv0_2_2)],true),[],to(q1r0_2,[sym(drt_rv0_3_2)],[])),
              tran(from(q0r0_2,[sym(drt_rv0_3_2)],true),[],to(q0r0_2,[sym(drt_rv0_4_2),sym(f__find_target_type_2)],[])),
              tran(from(q0r1_2,[sym(drt_rv0_4_2)],true),[],to(q0r0_2,[sym(drt_rv0_6_2)],[])),
              tran(from(q0r0_2,[sym(drt_rv0_4_2)],true),[],to(q0r0_2,[sym(drt_rv0_7_2)],[])),
              tran(from(q0r0_2,[sym(drt_rv0_6_2)],true),[],to(q0r0_2,[sym(drt_rv1_8_2)],[])),
              tran(from(q0r0_2,[sym(drt_rv0_7_2)],true),[],to(q0r0_2,[sym(drt_rv0_8_2)],[(targets,1)])),
              tran(from(q0r0_2,[sym(drt_rv1_8_2)],true),[],to(q0r0_2,[sym(drt_rv1_9_2)],[])),
              tran(from(q0r0_2,[sym(drt_rv0_8_2)],true),[],to(q0r0_2,[sym(drt_rv0_9_2)],[])),
              tran(from(q0r0_2,[sym(drt_rv1_9_2)],true),[],to(q0r0_2,[sym(drt_rv1_10_2)],[])),
              tran(from(q0r0_2,[sym(drt_rv0_9_2)],true),[],to(q0r0_2,[sym(drt_rv0_ret_2)],[])),
              tran(from(q0r0_2,[sym(drt_rv1_10_2)],true),[t(free)],to(q0r0_2,[sym(drt_rv1_ret_2)],[])),
              tran(from(q0r0_2,[sym(drt_rv1_10_2)],true),[t(free)],to(err_2,[sym(drt_rv1_10_2)],[])),
              tran(from(q0r0_2,[sym(drt_rv0_ret_2)],true),[],to(q0r1_2,[],[])),
              tran(from(q0r0_2,[sym(drt_rv1_ret_2)],true),[],to(q0r0_2,[],[])),
              tran(from(q0r0_2,[sym(dm_unregister_target_2)],true),[],to(q1r0_2,[sym(dur1_2)],[])),
              tran(from(q0r0_2,[sym(dur1_2)],true),[],to(q0r0_2,[sym(dur2_2),sym(f__find_target_type_2)],[])),
              tran(from(q0r0_2,[sym(dur2_2)],true),[],to(q0r0_2,[sym(dur3_2)],[])),
              tran(from(q0r1_2,[sym(dur2_2)],true),[],to(q0r0_2,[sym(dur5_2)],[])),
              tran(from(q0r0_2,[sym(dur3_2)],true),[],to(q0r0_2,[sym(dur4_2)],[])),
              tran(from(q0r0_2,[sym(dur4_2)],true),[],to(q0r0_2,[],[])),
              tran(from(q0r0_2,[sym(dur5_2)],true),[],to(q0r0_2,[sym(dur8_2)],[])),
              tran(from(q0r0_2,[sym(dur5_2)],true),[],to(q0r0_2,[sym(dur6_2)],[])),
              tran(from(q0r0_2,[sym(dur6_2)],true),[],to(q0r0_2,[sym(dur7_2)],[])),
              tran(from(q0r0_2,[sym(dur7_2)],true),[],to(q0r0_2,[],[])),
              tran(from(q0r0_2,[sym(dur8_2)],eq([targets],[0])),[t(list_underflow)],to(err_2,[sym(dur8_2)],[])),
              tran(from(q0r0_2,[sym(dur8_2)],true),[],to(q0r0_2,[sym(dur9_2)],[(targets,-1)])),
              tran(from(q0r0_2,[sym(dur9_2)],true),[t(free)],to(q0r0_2,[sym(dur10_2)],[])),
              tran(from(q0r0_2,[sym(dur9_2)],true),[t(free)],to(err_2,[sym(dur9_2)],[])),
              tran(from(q0r0_2,[sym(dur10_2)],true),[],to(q0r0_2,[sym(dur_ret_2)],[])),
              tran(from(q0r0_2,[sym(dur_ret_2)],true),[],to(q0r1_2,[],[])),
              tran(from(q0r0_2,[sym(dm_target_init_2)],true),[],to(q0r0_2,[sym(dm_register_target_2)],[])),
              tran(from(q0r0_2,[sym(dm_target_exit_2)],true),[],to(q0r0_2,[sym(dte1_2),sym(dm_unregister_target_2)],[])),
              tran(from(q0r0_2,[sym(dte1_2)],true),[t(expected_err)],to(q0r0_2,[],[])),
              tran(from(q0r1_2,[sym(dte1_2)],true),[],to(q0r0_2,[],[])),
              tran(from(q0r0_2,[sym(init_2)],true),[],to(q0r0_2,[sym(init_res_2),sym(dm_target_init_2)],[])),
              tran(from(q0r0_2,[sym(init_res_2)],true),[],to(q0r0_2,[],[])),
              tran(from(q0r1_2,[sym(init_res_2)],true),[],to(q0r0_2,[sym(test_2)],[])),
              tran(from(q0r0_2,[sym(test_2)],true),[],to(q0r0_2,[sym(done_2)],[])),
              tran(from(q0r0_2,[sym(test_2)],true),[],to(q0r0_2,[sym(reg_2),sym(dm_register_target_2)],[])),
              tran(from(q0r0_2,[sym(test_2)],true),[],to(q0r0_2,[sym(unreg_2),sym(dm_unregister_target_2)],[])),
              tran(from(q0r0_2,[sym(test_2)],true),[],to(q0r0_2,[sym(test_2),sym(dm_get_target_type_2)],[])),
              tran(from(q0r0_2,[sym(test_2)],true),[],to(q0r0_2,[sym(test_2),sym(dm_put_target_type_2)],[])),
              tran(from(q0r0_2,[sym(reg_2)],true),[],to(q0r0_2,[sym(test_2)],[])),
              tran(from(q0r1_2,[sym(reg_2)],true),[t(reg_succ)],to(q0r0_2,[sym(test_2)],[])),
              tran(from(q0r0_2,[sym(unreg_2)],true),[],to(q0r0_2,[sym(test_2)],[])),
              tran(from(q0r1_2,[sym(unreg_2)],true),[t(unreg_succ)],to(q0r0_2,[sym(test_2)],[])),
              tran(from(q0r0_2,[sym(done_2)],true),[],to(q0r0_2,[sym(done2_2),sym(dm_target_exit_2)],[])),
              tran(from(q0r0_2,[sym(done2_2)],true),[],to(fin0_2,[sym(done2_2)],[])),
              tran(from(q1r0_2,[sym(done2_2)],true),[],to(fin1_2,[sym(done2_2)],[])),
              tran(from(fin0_2,[sym(done2_2)],true),[t(final)],to(err_2,[sym(done2_2)],[])),
              tran(from(fin1_2,[sym(done2_2)],true),[t(final)],to(err_2,[sym(done2_2)],[])),
              tran(from(q1r0_2,[sym(f__find_target_type_2)],gt([targets],[0])),[],to(q1r0_2,[sym(ftt1_2)],[])),
              tran(from(q1r0_2,[sym(f__find_target_type_2)],true),[],to(q1r0_2,[sym(ftt_ret_2)],[])),
              tran(from(q1r0_2,[sym(ftt1_2)],true),[],to(q1r0_2,[sym(ftt2_2)],[])),
              tran(from(q1r0_2,[sym(ftt2_2)],true),[],to(q1r1_2,[],[])),
              tran(from(q1r0_2,[sym(ftt2_2)],true),[],to(q1r0_2,[sym(f__find_target_type_2)],[])),
              tran(from(q1r0_2,[sym(ftt_ret_2)],true),[],to(q1r0_2,[],[])),
              tran(from(q1r0_2,[sym(gtt1_2)],true),[],to(q1r0_2,[sym(gtt2_2),sym(f__find_target_type_2)],[])),
              tran(from(q1r0_2,[sym(gtt2_2)],true),[],to(q1r0_2,[sym(gtt_ret_2)],[])),
              tran(from(q1r1_2,[sym(gtt2_2)],true),[],to(q1r0_2,[sym(gtt3_2)],[])),
              tran(from(q1r0_2,[sym(gtt3_2)],true),[],to(q1r0_2,[sym(gtt4_2)],[])),
              tran(from(q1r0_2,[sym(gtt3_2)],true),[],to(q1r0_2,[sym(gtt5_2)],[])),
              tran(from(q1r0_2,[sym(gtt4_2)],true),[],to(q1r0_2,[sym(gtt_ret_2)],[])),
              tran(from(q1r0_2,[sym(gtt5_2)],true),[],to(q1r0_2,[sym(gtt_ret_2)],[])),
              tran(from(q1r0_2,[sym(gtt_ret_2)],true),[],to(q0r0_2,[],[])),
              tran(from(q1r0_2,[sym(dm_get_target_type_2)],true),[],to(q1r0_2,[sym(dgtt1_2)],[])),
              tran(from(q1r0_2,[sym(dm_get_target_type_2)],true),[],to(q1r0_2,[sym(dgtt_ret_2)],[])),
              tran(from(q1r0_2,[sym(dgtt1_2)],true),[],to(q1r0_2,[sym(dgtt2_2)],[])),
              tran(from(q1r0_2,[sym(dgtt2_2)],true),[],to(q1r0_2,[sym(dgtt_ret_2),sym(get_target_type_2)],[])),
              tran(from(q1r0_2,[sym(dgtt_ret_2)],true),[],to(q1r0_2,[],[])),
              tran(from(q1r0_2,[sym(dptt1_2)],true),[],to(q1r0_2,[sym(dptt2_2)],[])),
              tran(from(q1r0_2,[sym(dptt2_2)],true),[],to(q1r0_2,[sym(dptt3_2)],[])),
              tran(from(q1r0_2,[sym(dptt2_2)],true),[],to(q1r0_2,[sym(dptt4_2)],[])),
              tran(from(q1r0_2,[sym(dptt3_2)],true),[],to(q1r0_2,[sym(dptt4_2)],[])),
              tran(from(q1r0_2,[sym(dptt4_2)],true),[],to(q1r0_2,[sym(dptt5_2)],[])),
              tran(from(q1r0_2,[sym(dptt4_2)],true),[],to(q1r0_2,[sym(dptt5_2)],[])),
              tran(from(q1r0_2,[sym(dptt5_2)],true),[],to(q1r0_2,[sym(dptt_ret_2)],[])),
              tran(from(q1r0_2,[sym(dptt_ret_2)],true),[],to(q0r0_2,[],[])),
              tran(from(q1r0_2,[sym(alloc_target_2)],true),[],to(q1r0_2,[sym(at1_2)],[])),
              tran(from(q1r0_2,[sym(at1_2)],true),[t(alloc)],to(q1r0_2,[sym(at2_2)],[])),
              tran(from(q1r0_2,[sym(at2_2)],true),[],to(q1r0_2,[sym(at_ret_2)],[])),
              tran(from(q1r0_2,[sym(at2_2)],true),[],to(q1r0_2,[sym(at3_2)],[])),
              tran(from(q1r0_2,[sym(at3_2)],true),[],to(q1r0_2,[sym(at4_2)],[])),
              tran(from(q1r0_2,[sym(at4_2)],true),[],to(q1r0_2,[sym(at_ret_2)],[])),
              tran(from(q1r0_2,[sym(at_ret_2)],true),[],to(q1r0_2,[],[])),
              tran(from(q1r0_2,[sym(dm_register_target_2)],true),[t(here)],to(q1r0_2,[sym(drt_rv0_1_2)],[])),
              tran(from(q1r0_2,[sym(drt_rv0_1_2)],true),[],to(q1r0_2,[sym(drt_rv0_2_2),sym(alloc_target_2)],[])),
              tran(from(q1r0_2,[sym(drt_rv0_2_2)],true),[],to(q1r0_2,[sym(drt_rv0_3_2)],[])),
              tran(from(q1r0_2,[sym(drt_rv0_3_2)],true),[],to(q1r0_2,[sym(drt_rv0_4_2),sym(f__find_target_type_2)],[])),
              tran(from(q1r1_2,[sym(drt_rv0_4_2)],true),[],to(q1r0_2,[sym(drt_rv0_6_2)],[])),
              tran(from(q1r0_2,[sym(drt_rv0_4_2)],true),[],to(q1r0_2,[sym(drt_rv0_7_2)],[])),
              tran(from(q1r0_2,[sym(drt_rv0_6_2)],true),[],to(q1r0_2,[sym(drt_rv1_8_2)],[])),
              tran(from(q1r0_2,[sym(drt_rv0_7_2)],true),[],to(q1r0_2,[sym(drt_rv0_8_2)],[(targets,1)])),
              tran(from(q1r0_2,[sym(drt_rv1_8_2)],true),[],to(q0r0_2,[sym(drt_rv1_9_2)],[])),
              tran(from(q1r0_2,[sym(drt_rv0_8_2)],true),[],to(q0r0_2,[sym(drt_rv0_9_2)],[])),
              tran(from(q1r0_2,[sym(drt_rv1_9_2)],true),[],to(q1r0_2,[sym(drt_rv1_10_2)],[])),
              tran(from(q1r0_2,[sym(drt_rv0_9_2)],true),[],to(q1r0_2,[sym(drt_rv0_ret_2)],[])),
              tran(from(q1r0_2,[sym(drt_rv1_10_2)],true),[t(free)],to(q1r0_2,[sym(drt_rv1_ret_2)],[])),
              tran(from(q1r0_2,[sym(drt_rv1_10_2)],true),[t(free)],to(err_2,[sym(drt_rv1_10_2)],[])),
              tran(from(q1r0_2,[sym(drt_rv0_ret_2)],true),[],to(q1r1_2,[],[])),
              tran(from(q1r0_2,[sym(drt_rv1_ret_2)],true),[],to(q1r0_2,[],[])),
              tran(from(q1r0_2,[sym(dm_unregister_target_2)],true),[],to(q1r0_2,[sym(dur1_2)],[])),
              tran(from(q1r0_2,[sym(dur1_2)],true),[],to(q1r0_2,[sym(dur2_2),sym(f__find_target_type_2)],[])),
              tran(from(q1r0_2,[sym(dur2_2)],true),[],to(q1r0_2,[sym(dur3_2)],[])),
              tran(from(q1r1_2,[sym(dur2_2)],true),[],to(q1r0_2,[sym(dur5_2)],[])),
              tran(from(q1r0_2,[sym(dur3_2)],true),[],to(q1r0_2,[sym(dur4_2)],[])),
              tran(from(q1r0_2,[sym(dur4_2)],true),[],to(q0r0_2,[],[])),
              tran(from(q1r0_2,[sym(dur5_2)],true),[],to(q1r0_2,[sym(dur8_2)],[])),
              tran(from(q1r0_2,[sym(dur5_2)],true),[],to(q1r0_2,[sym(dur6_2)],[])),
              tran(from(q1r0_2,[sym(dur6_2)],true),[],to(q1r0_2,[sym(dur7_2)],[])),
              tran(from(q1r0_2,[sym(dur7_2)],true),[],to(q0r0_2,[],[])),
              tran(from(q1r0_2,[sym(dur8_2)],eq([targets],[0])),[t(list_underflow)],to(err_2,[sym(dur8_2)],[])),
              tran(from(q1r0_2,[sym(dur8_2)],true),[],to(q1r0_2,[sym(dur9_2)],[(targets,-1)])),
              tran(from(q1r0_2,[sym(dur9_2)],true),[t(free)],to(q1r0_2,[sym(dur10_2)],[])),
              tran(from(q1r0_2,[sym(dur9_2)],true),[t(free)],to(err_2,[sym(dur9_2)],[])),
              tran(from(q1r0_2,[sym(dur10_2)],true),[],to(q1r0_2,[sym(dur_ret_2)],[])),
              tran(from(q1r0_2,[sym(dur_ret_2)],true),[],to(q0r1_2,[],[])),
              tran(from(q1r0_2,[sym(dm_target_exit_2)],true),[],to(q1r0_2,[sym(dte1_2),sym(dm_unregister_target_2)],[])),
              tran(from(q1r0_2,[sym(dte1_2)],true),[t(expected_err)],to(q1r0_2,[],[])),
              tran(from(q1r1_2,[sym(dte1_2)],true),[],to(q1r0_2,[],[])),
              tran(from(q1r0_2,[sym(init_2)],true),[],to(q1r0_2,[sym(init_res_2),sym(dm_target_init_2)],[])),
              tran(from(q1r0_2,[sym(init_res_2)],true),[],to(q1r0_2,[],[])),
              tran(from(q1r1_2,[sym(init_res_2)],true),[],to(q1r0_2,[sym(test_2)],[])),
              tran(from(q1r0_2,[sym(test_2)],true),[],to(q1r0_2,[sym(done_2)],[])),
              tran(from(q1r0_2,[sym(test_2)],true),[],to(q1r0_2,[sym(reg_2),sym(dm_register_target_2)],[])),
              tran(from(q1r0_2,[sym(test_2)],true),[],to(q1r0_2,[sym(unreg_2),sym(dm_unregister_target_2)],[])),
              tran(from(q1r0_2,[sym(test_2)],true),[],to(q1r0_2,[sym(test_2),sym(dm_get_target_type_2)],[])),
              tran(from(q1r0_2,[sym(test_2)],true),[],to(q1r0_2,[sym(test_2),sym(dm_put_target_type_2)],[])),
              tran(from(q1r0_2,[sym(reg_2)],true),[],to(q1r0_2,[sym(test_2)],[])),
              tran(from(q1r1_2,[sym(reg_2)],true),[t(reg_succ)],to(q1r0_2,[sym(test_2)],[])),
              tran(from(q1r0_2,[sym(unreg_2)],true),[],to(q1r0_2,[sym(test_2)],[])),
              tran(from(q1r1_2,[sym(unreg_2)],true),[t(unreg_succ)],to(q1r0_2,[sym(test_2)],[])),
              tran(from(q1r0_2,[sym(done_2)],true),[],to(q1r0_2,[sym(done2_2),sym(dm_target_exit_2)],[]))],
              %tran(from(err_2,[sym(f__find_target_type_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(ftt1_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(ftt2_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(ftt_ret_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(get_target_type_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(gtt1_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(gtt2_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(gtt3_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(gtt4_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(gtt5_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(gtt_ret_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dm_get_target_type_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dgtt1_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dgtt2_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dgtt_ret_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dm_put_target_type_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dptt1_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dptt2_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dptt2_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dptt3_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dptt4_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dptt5_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dptt_ret_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(alloc_target_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(at1_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(at2_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(at3_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(at4_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(at_ret_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dm_register_target_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(drt_rv0_1_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(drt_rv0_2_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(drt_rv0_3_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(drt_rv0_4_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(drt_rv0_5_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(drt_rv0_6_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(drt_rv0_7_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(drt_rv1_8_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(drt_rv0_8_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(drt_rv1_9_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(drt_rv0_9_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(drt_rv1_10_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(drt_rv0_ret_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(drt_rv1_ret_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dm_unregister_target_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dur1_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dur2_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dur3_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dur4_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dur5_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dur6_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dur7_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dur8_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dur9_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dur10_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dur_ret_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dm_target_init_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dm_target_exit_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dte1_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(dte1_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(init_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(init_res_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(test_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(reg_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(unreg_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(done_2)],true),[],to(err_2,[],[])),
              %tran(from(err_2,[sym(done2_2)],true),[],to(err_2,[],[]))],
    GlobalInputSym = [t(reg_succ),
                      t(unreg_succ),
                      t(alloc),
                      t(free),
                      t(expected_err),
                      t(final),
                      t(list_underflow)],
    % attempt at explaining global trans:
    %   + in normal execution, one is waiting in waitj where j is the local
    %   return val, the other has some state girj, where i is the state of the
    %   global lock, j the local return val
    %
    %   + context switch means putting awake thread into waitj, and waitj-ing
    %   thread into girj (note j is local to both threads, so not same j)
    %
    %   + if a thread sees an error it goes to err and then other thread can
    %   abort with it
    %
    %   + it a thread is finished, it wakes up other thread, passing on state
    %   info (e.g. fin1 has lock set to one, so wakes up other with lock set to
    %   one)
    %
    %   + then fin1 will move to err as it is the final state, but it will
    %   output "final" on the way
    %
    %   + then formula can know if #(final) = 2, then both threads finished
    %   normally.  If #(final) < 2 then at least one thread aborted, and we can
    %   check for error conditions accordingly
    /*
    GlobalTrans = [tran(from(states(wait0_1,q0r0_2),true),[],to(states(q0r0_1,wait0_2),[])),
                   tran(from(states(wait1_1,q0r1_2),true),[],to(states(q0r1_1,wait1_2),[])),
                   tran(from(states(wait0_1,q1r0_2),true),[],to(states(q1r0_1,wait0_2),[])),
                   tran(from(states(wait1_1,q1r1_2),true),[],to(states(q1r1_1,wait1_2),[])),
                   tran(from(states(q0r0_1,wait0_2),true),[],to(states(wait0_1,q0r0_2),[])),
                   tran(from(states(q0r1_1,wait1_2),true),[],to(states(wait1_1,q0r1_2),[])),
                   tran(from(states(q1r0_1,wait0_2),true),[],to(states(wait0_1,q1r0_2),[])),
                   tran(from(states(q1r1_1,wait1_2),true),[],to(states(wait1_1,q1r1_2),[])),
                   tran(from(states(err_1,wait_2),true),[],to(states(err_1,err_2),[])),
                   %tran(from(states(wait_1,err_2),true),[],to(states(err_1,err_2),[])),
                   tran(from(states(wait0_1,err_2),true),[],to(states(err_1,err_2),[])),
                   tran(from(states(fin0_1,wait0_2),true),[],to(states(fin0_1,q0r0_2),[])),
                   tran(from(states(fin0_1,wait1_2),true),[],to(states(fin0_1,q0r1_2),[])),
                   tran(from(states(fin1_1,wait0_2),true),[],to(states(fin1_1,q1r0_2),[])),
                   tran(from(states(fin1_1,wait1_2),true),[],to(states(fin1_1,q1r1_2),[])),
                   tran(from(states(wait0_1,fin0_2),true),[],to(states(q0r0_1,fin0_2),[])),
                   tran(from(states(wait1_1,fin0_2),true),[],to(states(q0r1_1,fin0_2),[])),
                   tran(from(states(wait0_1,fin1_2),true),[],to(states(q1r0_1,fin1_2),[])),
                   tran(from(states(wait1_1,fin1_2),true),[],to(states(q1r1_1,fin1_2),[]))],
                   */
    VarNames = [targets],
    GlobalTrans = [tran(from(states(wait0_1,q0r0_2),true),[],to(states(q0r0_1,wait0_2),[])),
                   tran(from(states(wait1_1,q0r1_2),true),[],to(states(q0r1_1,wait1_2),[])),
                   tran(from(states(wait0_1,q1r0_2),true),[],to(states(q1r0_1,wait0_2),[])),
                   tran(from(states(wait1_1,q1r1_2),true),[],to(states(q1r1_1,wait1_2),[])),
                   tran(from(states(q0r0_1,wait0_2),true),[],to(states(wait0_1,q0r0_2),[])),
                   tran(from(states(q0r1_1,wait1_2),true),[],to(states(wait1_1,q0r1_2),[])),
                   tran(from(states(q1r0_1,wait0_2),true),[],to(states(wait0_1,q1r0_2),[])),
                   tran(from(states(q1r1_1,wait1_2),true),[],to(states(wait1_1,q1r1_2),[])),
                   tran(from(states(err_1,wait0_2),true),[],to(states(err_1,err_2),[])),
                   tran(from(states(err_1,wait1_2),true),[],to(states(err_1,err_2),[])),
                   tran(from(states(wait0_1,err_2),true),[],to(states(err_1,err_2),[])),
                   tran(from(states(wait1_1,err_2),true),[],to(states(err_1,err_2),[])),
                   tran(from(states(fin0_1,wait0_2),true),[],to(states(fin0_1,q0r0_2),[])),
                   tran(from(states(fin0_1,wait1_2),true),[],to(states(fin0_1,q0r1_2),[])),
                   tran(from(states(fin1_1,wait0_2),true),[],to(states(fin1_1,q1r0_2),[])),
                   tran(from(states(fin1_1,wait1_2),true),[],to(states(fin1_1,q1r1_2),[])),
                   tran(from(states(wait0_1,fin0_2),true),[],to(states(q0r0_1,fin0_2),[])),
                   tran(from(states(wait1_1,fin0_2),true),[],to(states(q0r1_1,fin0_2),[])),
                   tran(from(states(wait0_1,fin1_2),true),[],to(states(q1r0_1,fin1_2),[])),
                   tran(from(states(wait1_1,fin1_2),true),[],to(states(q1r1_1,fin1_2),[]))].



mycalldmtarget :-
    assert(synpco_optimize_flag), %set the optimize flag for synpco
    synpco_dm_target_correct(SynPCo),
    isvalid_synpco(SynPCo),
    open('output.txt',write,OS),
    ParikhConstraint = and(
    or(and([eq([t(final)],[2]),
            eq([t(reg_succ)],[t(unreg_succ)]), 
            or(gt([t(alloc)],[t(free)]),lt([t(alloc)],[t(free)])),
            eq([t(expected_err)],[0])]),
       and([lt([t(final)],[2]),
            or(gt([t(free)],[t(alloc)]),
               gt([t(list_underflow)],[0]))]))
    ,PresConst),
    %RevBound = [targets-2],
    %RevBound = 2,
    ConBound = 2,
    synpco_conswitch_to_counter(SynPCo,ConBound,SynPCo1,PresConst,CtxVar),
    RevBound = [targets-1,CtxVar-0],
    ( isvalid_synpco(SynPCo1) -> 
        true
    ; write('ERROR: SynPCo is invalid after synpco_conswitch'),
      write(SynPCo1), nl,
      fail
    ),
    write('Starting Translation'), nl,
    cbreach_synpco_to_z3_new(SynPCo1,RevBound,0,ParikhConstraint,OS),
    close(OS),
    write('Starting Z3'), nl.
    %shell('z3 /m output.txt').

mycalldmtarget1 :-
    assert(synpco_optimize_flag), %set the optimize flag for synpco
    synpco_dm_target_correct(SynPCo),
    isvalid_synpco(SynPCo),
    open('output.txt',write,OS),
    ParikhConstraint = 
    or(and([eq([t(final)],[2]),
            eq([t(reg_succ)],[t(unreg_succ)]), 
            or(gt([t(alloc)],[t(free)]),lt([t(alloc)],[t(free)])),
            eq([t(expected_err)],[0])]),
       and([lt([t(final)],[2]),
            or(gt([t(free)],[t(alloc)]),
               gt([t(list_underflow)],[0]))])),
    RevBound = [targets-1],
    %RevBound = 2,
    ConBound = 1,
    %synpco_conswitch_to_counter(SynPCo,ConBound,SynPCo1,PresConst,CtxVar),
    %( isvalid_synpco(SynPCo1) -> 
        %true
    %; write('ERROR: SynPCo is invalid after synpco_conswitch'),
      %write(SynPCo1), nl,
      %fail
    %),
    write('Starting Translation'), nl,
    cbreach_synpco_to_z3_new(SynPCo,RevBound,ConBound,ParikhConstraint,OS),
    close(OS),
    write('Starting Z3'), nl.
    %shell('z3 /m output.txt').
