get_regions(Boundaries,Var,Regions) :-
    is_list(Boundaries),
    get_regions(Boundaries,0,Var,Regions).


get_regions([],LowBound,Var,[geq([Var],[LowBound])]).
get_regions([0|Boundaries],_,Var,[eq([Var],[0])|Regions]) :-
    !,
    get_regions(Boundaries,1,Var,Regions).

get_regions([Boundary|Boundaries],LowBound,Var,Regions) :-
    Boundary > 0,
    LowBound =< Boundary,
    ( LowBound =:= Boundary ->
        Regions = [eq([Var],[Boundary])|RestRegions]
    ; Regions = [and(geq([Var],[LowBound]),lt([Var],[Boundary])),
                 eq([Var],[Boundary])|RestRegions]
    ),
    NewLowBound is Boundary+1,
    get_regions(Boundaries,NewLowBound,Var,RestRegions).
